/*
 * arpa/nameser.h 1998/05/01
 * Modified by K.Shirakata
 * Modified by Kazuya 'Sharl' Masuda
 */

/* domain name section */
#ifndef	__arpa_nameser_h__
#define	__arpa_nameser_h__
struct dns
{
  struct dns *prev;
  struct dns *next;

  long address;
};

/*
 * Type values for resources and queries
 */
#define T_A		1		/* host address */
#define T_NS		2		/* authoritative server */
#define T_MD		3		/* mail destination */
#define T_MF		4		/* mail forwarder */
#define T_CNAME		5		/* connonical name */
#define T_SOA		6		/* start of authority zone */
#define T_MB		7		/* mailbox domain name */
#define T_MG		8		/* mail group member */
#define T_MR		9		/* mail rename name */
#define T_NULL		10		/* null resource record */
#define T_WKS		11		/* well known service */
#define T_PTR		12		/* domain name pointer */
#define T_HINFO		13		/* host information */
#define T_MINFO		14		/* mailbox information */
#define T_MX		15		/* mail routing information */
#define T_TXT		16		/* text strings */
#define T_ANY		255		/* wildcard match */

/*
 * Values for class field
 */
#define C_IN		1		/* the arpa internet */
#define C_ANY		255		/* wildcard match */

/*
 * Currently defined opcodes
 */
#define QUERY		0x0		/* standard query */
#define IQUERY		0x1		/* inverse query */

/*
 * Structure for passing resource records around.
 */
struct rrec {
  short r_zone;			/* zone number */
  short r_class;		/* class number */
  short r_type;			/* type number */
  unsigned long r_ttl;		/* time to live */
  int r_size;			/* size of data area */
  char *r_data;			/* pointer to data */
};

int isipaddr(char *);
unsigned long htonl(unsigned long);
unsigned short htons(unsigned short);
unsigned long ntohl(unsigned long);
unsigned short ntohs(unsigned short);

#endif
